<%@ page language="java" contentType="text/html; charset=UTF-8" %>
<html>
<%!/**
 * 将容易引起xss漏洞的半角字符直接替换成全角字符
 */
public String xssEncode(String s) {
    if (s == null || s.isEmpty()) { return s; }
    StringBuilder sb = new StringBuilder(s.length() + 16);
    for (int i = 0; i < s.length(); i++) {
        char c = s.charAt(i);
        switch (c) {
            case '>': sb.append('＞'); break; //全角大于号
            case '<': sb.append('＜'); break; //全角小于号
            case '\'': sb.append('‘'); break; //全角单引号
            case '\"': sb.append('“'); break; //全角双引号
            case '&': sb.append('＆'); break; //全角
            case '\\': sb.append('＼');break; //全角斜线
            case '#': sb.append('＃'); break; //全角井号
            default: sb.append(c); break;
        }
    }
    return sb.toString();
}
%>
<%
String basePath  = request.getContextPath()+"/static/";

String upgradeProcess = xssEncode(request.getParameter("upgradeProcess"));
String backup = xssEncode(request.getParameter("backup"));
if(upgradeProcess==null) {
	upgradeProcess = "";
}
if(backup == null) {
	backup = "";
}
%>
<script src="<%=basePath %>/js/jquery/jquery.js" type="text/javascript"></script> 
<script src="<%=basePath %>/bootstrap/js/bootstrap.min.js"></script> 
<link href="<%=basePath %>/bootstrap/css/bootstrap.min.css" rel="stylesheet">
<head>
	<title> E-cology升级程序</title>
	<script type="text/javascript">
	
	//重新刷新方法
	parent.refreshPage = function(){
		getData();
	};
	
	var timeout2;
	var eachwidth = 30;
	var upgradeProcess = "<%=upgradeProcess%>";
	var backup = "<%=backup%>";
	$(document).ready(function(){
		if("1"==backup) {
		 	$.ajax({
				url:"/cp/e_upgrade_upgradeOperation.json",
				type:"post",
				datatype:"json",
				headers: {
			        Accept: "application/json; charset=utf-8"
			    },
				contentType:"application/json; charset=utf-8",
				data:JSON.stringify({operationtype:"backup"}),
				success:function(data){	
				}
			});
		} else {
			getData();
		}


		timeout2=setInterval(getData,1000);
		$(parent.document.getElementById("nextbutton")).css("display","none");
		$(parent.document.getElementById("continuebutton")).css("display","none");
		$(parent.document.getElementById("backupbtn")).css("display","none");
		$(parent.document.getElementById("refreshbutton")).css("display","");
		
		$("#cancelconfirm").on("click",function(){
			if(!parent.document.getElementById("cancelbackup")){
	 			$(parent.document.getElementById("cancelbackup")).remove();
	 		}
			if(!parent.document.getElementById("back")){
	 			$(parent.document.getElementById("back")).remove();
	 		}
			
			$(parent.parent.document).find("#iframe1").attr("src","eupgrade_upgradeProcess?step=0&upgradeProcess=0");
			$("#modal1").modal("hide");
		});
	});
	
	
	function getData(){
		$.ajax({
			url:"/cp/e_upgrade_getInfo.json",
			type:"post",
			datatype:"json",
			headers: {
		        Accept: "application/json; charset=utf-8"
		    },
			contentType:"application/json; charset=utf-8",
			data:JSON.stringify({operationtype:"backup"}),
			success:function(data){			
				 var res = data.data; 		
	 			 var backupprocess = res.backupprocess;
	 			 var filecount = res.filecount;
	 			 var filecurrent = res.filecurrent;
	 			 
	 			 $(".progress-bar").css("width",backupprocess+"%");
	 	     	  if(backupprocess == "0") {
	 	     		$("#message").html("开始解压备份文件...");
	 	     	  } else if(backupprocess == "20"){
	 	     		$("#message").html("正在还原ecology..."+"（文件总数："+filecount+",已还原："+filecurrent+")");
	 	     	  }else if(backupprocess == "40") {
	 	     		$("#message").html("正在还原emobile..."+"（文件总数："+filecount+",已还原："+filecurrent+")"); 
	 	     	  } else if(backupprocess == "60") {
	 	     		$("#message").html("正在还原emessage..."+"（文件总数："+filecount+",已还原："+filecurrent+")");
	 	     	  } else if(backupprocess == "80") {
	 	     		$("#message").html("正在还原resin..."+"（文件总数："+filecount+",已还原："+filecurrent+")");
	 	     	  } else if(backupprocess == "90") {
	 	     		$("#message").html("正在删除临时文件...");
	 	     	  } else if(backupprocess == "100"){
	 	     		$("#message").html("还原成功，请手动还原数据库。");
	 	     		clearInterval(timeout2);
	 	     		if(!parent.document.getElementById("back")) {
	 	   				$(parent.document.getElementById("btndiv")).append("<button type=\"button\" class=\"btn btn-success\" onclick=\"cancelBackup(1);\" id=\"back\" name=\"back\">返回</button>");
	 	   			}
	 	     		//parent.nextbutton.disabled = false;
	 	     	  } else if(backupprocess == "error"){
	 	     		clearInterval(timeout2);
	 	     		$("#message").html("还原失败，请重新进行升级。");
	 	     		if(!parent.document.getElementById("cancelbackup")) {
	 	   				$(parent.document.getElementById("btndiv")).append("<button type=\"button\" class=\"btn btn-success\" onclick=\"cancelBackup(0);\" id=\"cancelbackup\" name=\"cancelbackup\">重新升级</button>");
	 	   			}
	 	     	  }
				
				
			}
		});	
	}
	
	//取消
	parent.cancelBackup = function (param) {
		//var name = $(this).attr("id");
		//alert(param);
		if(param=="0") {
			$("#modal1content").html("还原失败，确认重新升级？");
		} else {
			$("#modal1content").html("还原成功，返回升级页面。");
		}
		$("#modal1").modal("show");

	}
	</script>
</head>
<body>
<div id="modal1" class="modal fade" tabindex="-1" role="dialog">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title">提示信息</h4>
      </div>
      <div class="modal-body">
        <p id="modal1content">还原失败，确认重新升级？</p>
      </div>
      <div class="modal-footer">
         <button type="button" class="btn btn-default" id="cancelconfirm">确认</button>
         <button type="button" class="btn btn-default" data-dismiss="modal" id="backcancel">取消</button>
      </div>
    </div>
  </div>
</div>

<div style="width:100%;height:100%;float:right">
<input id="process" type="hidden"></input>
	<div  style="height:380px;">
			<div style="height:370px;width:100%;float:right;margin-top:10px;">
				<div style="height:100%;width:100%;margin-top:100px">
                      <div style="margin-top:10px;text-align: center;" >
                      	<div class="progress">
						    <div class="progress-bar progress-bar-success" role="progressbar" aria-valuenow="60" 
						        aria-valuemin="0" aria-valuemax="100" style="width:0%;">
						        <span class="sr-only"></span>
						    </div>
						</div>
                      </div>
                       <div style="margin-top:0px;height:20px;text-align: center;font-size: 15px;" >
                       <p id="message">开始还原...</p>
                       </div>
				</div>
			
			</div>
	</div>
</div>
</body>
</html>