<%@ page language="java" contentType="text/html; charset=UTF-8" %>
<html>
<%!/**
 * 将容易引起xss漏洞的半角字符直接替换成全角字符
 */
public String xssEncode(String s) {
  if (s == null || s.isEmpty()) { return s; }
  StringBuilder sb = new StringBuilder(s.length() + 16);
  for (int i = 0; i < s.length(); i++) {
    char c = s.charAt(i);
    switch (c) {
      case '>': sb.append('＞'); break; //全角大于号
      case '<': sb.append('＜'); break; //全角小于号
      case '\'': sb.append('‘'); break; //全角单引号
      case '\"': sb.append('“'); break; //全角双引号
      case '&': sb.append('＆'); break; //全角
      case '\\': sb.append('＼');break; //全角斜线
      case '#': sb.append('＃'); break; //全角井号
      default: sb.append(c); break;
    }
  }
  return sb.toString();
}
%>
<%
String basePath  = request.getContextPath()+"/static/";

String message = (String)request.getSession().getAttribute("message");
String candonext = xssEncode(request.getParameter("candonext"));
%>
<head>
<link href="<%=basePath %>bootstrap/css/bootstrap.min.css" rel="stylesheet">
<script src="<%=basePath %>js/jquery/jquery.js" type="text/javascript"></script> 
<script src="<%=basePath %>bootstrap/js/bootstrap.min.js"></script> 
<link href="<%=basePath %>bootstrap-table/bootstrap-table.min.css" rel="stylesheet">
<script src="<%=basePath %>bootstrap-table/bootstrap-table.min.js"></script>
<script src="<%=basePath %>bootstrap-table/locale/bootstrap-table-zh-CN.min.js"></script>

<title> E-cology升级程序</title>
<style type="text/css">
.input-group {
	display:inline-table;
	width:30%;
}
.input-group-addon {
	width:120px;
}
th {
	background-color:bisque;
}
</style>
<script type="text/javascript">

$(document).ready(function(){
	var message = "<%=message%>";
	var candonext = "<%=candonext%>";
	$(parent.document.getElementById("refreshbutton")).css("display","none");
	if(candonext == "0") {
		$(parent.document.getElementById("nextbutton")).css("display","");
		$(parent.document.getElementById("nextbutton")).attr("disabled",false);
	} else {
		$(parent.document.getElementById("nextbutton")).css("display","none");
	}
	
	//初始化
	init();
	$("#mytabdiv").css("height","60%");
	
});


//根据窗口调整表格高度
$(window).resize(function() {
    $('#mytab').bootstrapTable('resetView', {
       // height: tableHeight()
    });
    $("#mytabdiv").css("height","60%");
})
function init() {
	//生成用户数据
	$('#mytab').bootstrapTable({
	    method: 'post',
	    url:"/cp/e_upgrade_getUpgradeHistoryJson.json",//要请求数据的文件路径
        toolbar: '#toolbar',                //工具按钮用哪个容器
        striped: true,                      //是否显示行间隔色
        cache: false,                       //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        pagination: true,                   //是否显示分页（*）
        sortable: false,                     //是否启用排序
        sortOrder: "asc",                   //排序方式
        sidePagination: "client",           //分页方式：client客户端分页，server服务端分页（*）
        dataLocale:"zh-CN", //表格汉化
        pageNumber:1,                       //初始化加载第一页，默认第一页
        pageSize: 10,                       //每页的记录行数（*）
        toolbarAlign:"right",
        queryParams:function() {
        	var params= {
        			packagename: $("#packagename").val(),
        			packageno: $("#packageno").val(),
        	};
        	return params;
        },//传递参数（*）
        pageList: [10, 20, 50, 100],        //可供选择的每页的行数（*）
        //search: true,                       //是否显示表格搜索，此搜索是客户端搜索，不会进服务端，所以，个人感觉意义不大
        strictSearch: true,
       // showColumns: true,                  //是否显示所有的列
       //showRefresh: true,                  //是否显示刷新按钮
        minimumCountColumns: 2,             //最少允许的列数
        clickToSelect: true,                //是否启用点击选中行
        //height:500,                        //行高，如果没有设置height属性，表格自动根据记录条数觉得表格高度
        uniqueId: "id",                     //每一行的唯一标识，一般为主键列
       // showToggle:true,                    //是否显示详细视图和列表视图的切换按钮
       // cardView: false,                    //是否显示详细视图
       // detailView: false,                   //是否显示父子表
	    columns: [
//         {
//             title:'选择',
//             field:'select',
//             //复选框
//             checkbox:false,
//             width:"20px",
//             align:'center',
//             valign:'middle'
//         },
	    {
	        field: 'id',
	        title: 'ID',
	    }, {
	        field: 'label',
	        title: '补丁包编号',
	    }, {
	    	field: 'packagename',
	        title: '名称',
	    }, {
	    	field: 'content',
	        title: '补丁包内容',
	    }, {
	    	field: 'configcontent',
	        title: '配置信息',
	       
	    }, {
	    	field: 'operationdate',
	        title: '操作日期'
	    }, {
	    	field: 'upgradefileinfo',
	        title: '升级文件信息'
	    }
	    
	    ]
	});
}

//三个参数，value代表该列的值
function operateFormatter(value,row,index){
    if(value==2){
        return '<i class="fa fa-lock" style="color:red"></i>'
    }else if(value==1){
        return '<i class="fa fa-unlock" style="color:green"></i>'
    }else{
        return '数据错误'
    }
}
//请求服务数据时所传参数
function queryParams(params){
    return{
        //每页多少条数据
        pageSize: params.limit,
        //请求第几页
        pageIndex:params.pageNumber,
        Name:$('#search_name').val(),
        Tel:$('#search_tel').val()
    }
}

 
function tableHeight(){
    //可以根据自己页面情况进行调整
    return $(window).height() -280;
}

function search() {

	$("#mytab").bootstrapTable('refresh');

}

/**
 * 显示信息
 */
function openMessage(id,flage,label) {
	var v = flage;
	//if(v=="1") {
	//	doOpen("eupgrade_packageInfoDetail.html?ishistory=1&message=content&id="+id+"&label="+label,"补丁包内容");
	//} else {
	//	doOpen("eupgrade_packageInfoDetail.html?ishistory=1&message=config&id="+id+"&label="+label,"配置详情");
	//}
	$.ajax({
		url:"/cp/e_upgrade_getPackageInfoDetailJson.json",
		type:"post",
		datatype:"json",
		headers: {
	        Accept: "application/json; charset=utf-8"
	    },
		contentType:"application/json; charset=utf-8",
		data:JSON.stringify({id:id,flage:flage,label:label}),
		success:function(data){	
			var data = data.data;
			var content = "";
			try {
				content = data.res;
			} catch(e) {
				
			}
			//alert(content);
			showcontent(content);
		}
	});	
}
/**
 * 下载文件
 */
function onDown(id,flage,label) {
	$.ajax({
		url:"/cp/edownload_upgradeDownload.json",
		type:"post",
		datatype:"json",
		headers: {
	        Accept: "application/json; charset=utf-8"
	    },
		contentType:"application/json; charset=utf-8",
		data:JSON.stringify({type:"packagedetail",filetype:flage,label:label}),
		success:function(data){	
			var filepath = data.data.filepath;
            alert(filepath);
			filepath = encodeURIComponent(filepath)
			document.getElementById("excels").src = "eupgrade_download.html?filepath="+filepath;
			
		}
	});
	
	//document.getElementById("excels").src = "edownload_upgradeDownload.html?type=packagedetail&filetype="+flage+"&label="+label;
}

function showcontent(content) {
	$("#modal1content").html(content);
	$("#modal1").modal("show");
}

function doOpen(url,title) {
	$("#modal-title2").text(title);
	$("#iframe2").attr("src",url);
	$("#modal2").modal("show");
}

function downloadupgradefile(downloadtype,label) {
	$.ajax({
		url:"/cp/edownload_upgradeDownload.json",
		type:"post",
		datatype:"json",
		contentType:"application/json; charset=utf-8",
		headers: {
	        Accept: "application/json; charset=utf-8"
	    },
		data:JSON.stringify({type:"filedetail",filetype:downloadtype,label:label}),
		success:function(data){	
			var filepath = data.data.filepath;
            
			filepath = encodeURIComponent(filepath)
			document.getElementById("excels").src = "eupgrade_download.html?filepath="+filepath;
			
		}
	});	
}

</script>
 </head>
<%
 String titlename =""; 
 %>
<%
%>
<body style="height:100%;width:100%;"> 
<div id="modal1" class="modal fade" tabindex="-1" role="dialog">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title">信息</h4>
      </div>
      <div class="modal-body">
        <p id="modal1content"></p>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">确认</button>
      </div>
    </div>
  </div>
</div>

<div id="modal2" class="modal fade" tabindex="-1" role="dialog">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title" id="modal-title2"></h4>
      </div>
      <div class="modal-body">
        <iframe src="" id="iframe2"></iframe>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">确认</button>
      </div>
    </div>
  </div>
</div>

<br>
<div class="input-group">
  <span class="input-group-addon">名称</span>
  <input type="text" class="form-control" name="packagename" id="packagename">
</div>
<div class="input-group">
  <span class="input-group-addon">补丁包编号</span>
  <input type="text" class="form-control" name="packageno" id="packageno">
</div>
<div class="input-group" style="float:right;margin-right:10px">
	<input type="button" class="btn btn-info" style="width:85px;background-color:#0070c1;float:right"  id="btn_add"  onclick="search()" value="查询">
</div>

<div id="mytabdiv" style="width:100%;height:80%">

<table id="mytab" class="table table-hover" ></table>
</div>
<iframe name="excels" id="excels" src="" style="display:none" ></iframe> 
</body>
</html>